#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <string.h>

void erro(char*);

int main(int argc, char *argv[]){
	int sock, er, client_addr_size;
	struct sockaddr_in addr, client_addr;
	static char mens_in[255], mens_out[255];
	int port = 4400;
	
	if (argc != 2) erro("servidor <porta>\n");
	
	/* Configura o sock_ser */
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;             /* tipo */
	addr.sin_addr.s_addr = htonl(INADDR_ANY);	/* interface */
	addr.sin_port = htons((int) atoi(argv[1]));         /* fake port */
	
	/* Cria o socket */
	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) erro("socket");
	
	/* Abre o socket na forma de bind */
	if (bind(sock, (struct sockaddr *) &addr, sizeof(addr)) < 0) erro("bind");

	/* O socket fica ouvindo mensagens que vem do socket */
	if (listen(sock, 1) < 0) erro("listen");
	
	client_addr_size = sizeof(client_addr);
	if ((sock = accept(sock, (struct sockaddr *) &client_addr, &client_addr_size)) < 0) erro("accept");

	/* espera uma mensagem e retorna uma confirmacao */
	while ((er = read(sock, mens_in, sizeof(mens_in))) > 0) {
		printf("Mensagem recebida: %s\n", mens_in);
		sprintf(mens_out, "Confirmado [%s]", mens_in);
		write(sock, mens_out, sizeof(mens_out));
		printf("Mensagem enviada: %s\n", mens_out);
	}
	close(sock);
	exit(0);
}

void erro(char *msg) {
	printf("Erro: %s\n", msg);
	exit(-1);
}
