#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock.h>

void process_client(int);
void erro(char*);

int main(int argc, char *argv[]) {
	int local_socket, remote_socket, remote_length;
	struct sockaddr_in local_address, remote_address;
	WSADATA wsa_data;

	// O parametro precisa ser a porta local
	if (argc != 2) {
		erro("srvw <porta>\n");
	}
	 // inicia o Winsock 2.0 (DLL), Only for Windows
    if (WSAStartup(MAKEWORD(2, 0), &wsa_data) != 0) {
        erro("WSAStartup() failed\n");
	}
    // criando o socket local para o servidor
    local_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (local_socket == INVALID_SOCKET) {
		WSACleanup();
		erro("socket() failed\n");
    }

    memset(&local_address, 0, sizeof(local_address));
    local_address.sin_family = AF_INET; // internet address family
    local_address.sin_addr.s_addr = htonl(INADDR_ANY); // endereco inet_addr("127.0.0.1")
    local_address.sin_port = htons((short) atoi(argv[1])); // porta local
 
	// interligando o socket com o endereo (local)
	if (bind(local_socket,(struct sockaddr*) &local_address, sizeof(local_address)) == SOCKET_ERROR) {
		WSACleanup();
		closesocket(local_socket);
		erro("bind");
	}
    // coloca o socket para escutar as conexoes
    if (listen(local_socket, 5) == SOCKET_ERROR) {
        WSACleanup();
        closesocket(local_socket);
        erro("listen() failed\n");
    }
	while (1) {
		remote_length = sizeof(remote_address);
		remote_socket = accept(local_socket, (struct sockaddr *) &remote_address, &remote_length);
		if(remote_socket == INVALID_SOCKET) {
			WSACleanup();
			closesocket(local_socket);
			erro("accept() failed\n");
		} else {
			process_client(remote_socket);
		}
	}
	return 0;
}

void process_client(int remote_socket) {
	int message_length = 0;
	char msg_in[255], msg_out[255];
	do {
		message_length = recv(remote_socket, msg_in, sizeof(msg_in), 0);
		printf("%s\n", msg_in);
		sprintf(msg_out, "retorno [%s]", msg_in);

		if (message_length > 0) {
			if (send(remote_socket, msg_out, sizeof(msg_out), 0) == SOCKET_ERROR) {
				WSACleanup();
				closesocket(remote_socket);
				erro("send() failed\n");
			}
		}
	} while (message_length > 0);
	close(remote_socket);
}

void erro(char *msg) {
	printf("Erro: %s\n", msg);
	exit(-1);
}

 
 
 
 
